package immibis.tubestuff;

import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.Init;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.network.IGuiHandler;
import cpw.mods.fml.common.network.NetworkMod;
import cpw.mods.fml.common.network.NetworkRegistry;
import net.minecraft.client.Minecraft;
import net.minecraft.server.MinecraftServer;
import net.minecraft.src.*;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.ForgeSubscribe;
import net.minecraftforge.event.entity.player.EntityItemPickupEvent;
import ic2.api.Ic2Recipes;
import ic2.common.Ic2Items;
import immibis.core.*;
import immibis.core.api.IBlockIDCallback;
import immibis.core.api.IDAllocator;
import immibis.core.api.porting.PortableBaseMod;
import immibis.core.api.porting.SidedProxy;
import immibis.core.net.IPacket;
import immibis.core.net.IPacketMap;
import immibis.core.net.OneTwoFiveNetworking;

@Mod(modid="Tubestuff", name="Tubestuff", version="51.0.2", useMetadata=true, dependencies="required-after:ImmibisCore")
@NetworkMod(clientSideRequired=true, serverSideRequired=false)
public class TubeStuff extends PortableBaseMod implements IPacketMap {
	public static TubeStuff instance;
	public static BlockTubestuff block;
	public static BlockStorage blockStorage;
	public static Item itemUseless;
	
	public static boolean enableSlowFalling;
	
	private static EntityPlayerFakeTS fakePlayer;
	
	public static final int GUI_BUFFER = 0;
	public static final int GUI_TABLE = 1;
	public static final int GUI_CHEST = 2;
	public static final int GUI_LOGICCRAFTER = 3;
	public static final int GUI_RETRIEVULATOR = 4;
	public static final int GUI_DUPLICATOR = 5;
	
	public static final byte PKT_BLOCK_BREAKER_DESC = 0;
	
	public static final String CHANNEL = "TubeStuff";
	
	public static EntityPlayerFakeTS fakePlayer(World world) {
		if(fakePlayer == null)
			fakePlayer = new EntityPlayerFakeTS(world);
		return fakePlayer;
	}
	
	public TubeStuff() {
		instance = this;
	}
	
	public String getPriorities() {
		return "after:mod_ImmibisCore";
	}
	
	private boolean hadFirstTick = false;
	@Override
	public boolean onTickInGame() {
		if(!hadFirstTick) {
			SharedProxy.FirstTick();
			hadFirstTick = true;
		}
		return false;
	}

	@Init
	public void load(FMLInitializationEvent evt) {
		BlockTubestuff.model = SidedProxy.instance.getUniqueBlockModelID("immibis.tubestuff.BlockRenderer", true);
		
		enableClockTicks(true);
		enableClockTicks(false);
		
		NetworkRegistry.instance().registerGuiHandler(this, new IGuiHandler() {
			
			@Override
			public Object getServerGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z) {
				TileEntity tile = world.getBlockTileEntity(x, y, z);
				switch(ID) {
				case GUI_BUFFER:
					return new ContainerChest(player.inventory, (TileBuffer)tile);
				case GUI_TABLE:
					return new ContainerAutoCraftingMk2(player, (TileAutoCraftingMk2)tile);
				case GUI_CHEST:
					return new ContainerBlackHoleChest(player, (TileBlackHoleChest)tile);
				case GUI_LOGICCRAFTER:
					return new ContainerLogicCrafter(player, (TileLogicCrafter)tile);
				case GUI_DUPLICATOR:
					return new ContainerOneSlot(player, ((TileDuplicator)tile).getGuiInventory());
				case GUI_RETRIEVULATOR:
					return new ContainerRetrievulator(player, (TileRetrievulator)tile);
				}
				return null;
			}
			
			@Override
			public Object getClientGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z) {
				TileEntity tile = world.getBlockTileEntity(x, y, z);
				switch(ID) {
				case GUI_BUFFER:
					return new GuiChest(player.inventory, (TileBuffer)tile);
				case GUI_TABLE:
					return new GuiAutoCraftingMk2(player, (TileAutoCraftingMk2)tile);
				case GUI_CHEST:
					return new GuiBlackHoleChest(player, (TileBlackHoleChest)tile);
				case GUI_LOGICCRAFTER:
					return new GuiLogicCrafter(player, (TileLogicCrafter)tile);
				case GUI_DUPLICATOR:
					return new GuiOneSlot(new ContainerOneSlot(player, ((TileDuplicator)tile).getGuiInventory()), "Duplicator");
				case GUI_RETRIEVULATOR:
					return new GuiRetrievulator(player, (TileRetrievulator)tile);
				}
				return null;
			}
		});
		
		IDAllocator.RegisterBlockID("tubestuff", new IBlockIDCallback() {
			@Override
			public void registerBlock(int id) {
				block = new BlockTubestuff(id);
				ModLoader.registerBlock(block, ItemTubestuff.class);
			}
		});
		
		ModLoader.registerTileEntity(TileBuffer.class, "TubeStuff buffer");
		ModLoader.registerTileEntity(TileAutoCraftingMk2.class, "TubeStuff crafting table");
		ModLoader.registerTileEntity(TileLogicCrafter.class, "TubeStuff logic crafter");
		ModLoader.registerTileEntity(TileRetrievulator.class, "TubeStuff retrievulator");
		ModLoader.registerTileEntity(TileIncinerator.class, "TubeStuff incinerator");
		ModLoader.registerTileEntity(TileDuplicator.class, "TubeStuff duplicator");
		SidedProxy.instance.registerTileEntity(TileBlackHoleChest.class, "TubeStuff infinite chest", "immibis.tubestuff.RenderTileBlackHoleChest");
		SidedProxy.instance.registerTileEntity(TileBlockBreaker.class, "TubeStuff block breaker", "immibis.tubestuff.RenderTileBlockBreaker");
		
		SharedProxy.enableStorageBlocks = Config.getBoolean("tubestuff.enableStorageBlocks", true);
		SharedProxy.enableStorageBlocksVanilla = Config.getBoolean("tubestuff.enableStorageBlocks.vanilla", true);
		SharedProxy.enableStorageBlockOreDictionary = Config.getBoolean("tubestuff.enableStorageBlocks.useOreDictionary", true);
		
		enableSlowFalling = Config.getBoolean("tubestuff.enableSlowDustFalling", false);
		
		if(SharedProxy.enableStorageBlocks) {
			IDAllocator.RegisterBlockID("tubestuff.storage", new IBlockIDCallback() {
				
				@Override
				public void registerBlock(int id) {
					blockStorage = new BlockStorage(id);
					ModLoader.registerBlock(blockStorage, ItemStorage.class);
				}
			});
		}
		
		itemUseless = (new Item(Config.getItemID("tubestuff.uselessItem", 7614)-256));
		itemUseless.setTextureFile("/immibis/tubestuff/blocks.png");
		itemUseless.setItemName("tubestuff.uselessItem");
		itemUseless.setIconIndex(5);
		itemUseless.setMaxStackSize(1);
		ModLoader.addName(itemUseless, "Retriever jammer");
		
		MinecraftForge.EVENT_BUS.register(this);
		
		try {
			Ic2Recipes.addRecyclerBlacklistItem(itemUseless);
		} catch(Throwable e) {
			
		}
		
		OneTwoFiveNetworking.initReceiveClient(this, CHANNEL);
	}
	
	public static final boolean areItemsEqual(ItemStack recipe, ItemStack input)
	{
		return input.itemID == recipe.itemID && (!input.getHasSubtypes() || input.getItemDamage() == recipe.getItemDamage());
	}
	
	@ForgeSubscribe
	public void onPickup(EntityItemPickupEvent evt) {
		if(evt.item.item != null && evt.item.item.stackSize > 0 && evt.item.item.itemID == itemUseless.shiftedIndex) {
			evt.item.setDead();
			evt.setCanceled(true);
		}
	}

	private static Object bcWrenchItem = null, icWrenchItem = null;
	
	/**
	 * Accepts any of the following items:
	 * <ul>
	 * <li>BuildCraft wrench</li>
	 * <li>IndustrialCraft wrench</li>
	 * <li>RedPower screwdriver</li>
	 * <li>RedPower sonic screwdriver (if charged)</li>
	 * <li>Vanilla stone hoe</li>
	 * </ul>
	 * No charge or durability is used.
	 */
	public static boolean isValidWrench(ItemStack s) {
		if(s == null)
			return false;
		
		Item i = s.getItem();
		if(i == Item.hoeStone)
			return true;
		
		if(bcWrenchItem == null) {
			try {
				try {
					try {
						bcWrenchItem = (Item)Class.forName("buildcraft.BuildCraftCore").getDeclaredField("wrenchItem").get(null);
					} catch(Throwable e) {
						bcWrenchItem = (Item)Class.forName("BuildCraftCore").getDeclaredField("wrenchItem").get(null);
					}
				} catch(Throwable e) {
					bcWrenchItem = (Item)Class.forName("net.minecraft.src.buildcraft.BuildCraftCore").getDeclaredField("wrenchItem").get(null);
				}
			} catch(Throwable e) {
				bcWrenchItem = new Object();
			}
		}
		
		if(icWrenchItem == null) {
			try {
				icWrenchItem = Ic2Items.wrench.getItem();
			} catch(Throwable e) {
				icWrenchItem = new Object();
			}
		}
		
		if(i == bcWrenchItem || i == icWrenchItem)
			return true;
		
		if(RedPowerItems.useScrewdriver(s))
			return true;
		
		return false;
	}
	
	@Override
	public IPacket createPacket(byte id) {
		switch(id) {
		case PKT_BLOCK_BREAKER_DESC: return new PacketBlockBreakerDescription();
		default: return null;
		}
	}
}
